/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package rs.ds.trans.example3.start;

import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.AnnotationConfigApplicationContext;
import org.springframework.stereotype.Component;
import rs.ds.trans.example3.config.TransPersistenceJPAConfig;
import rs.ds.trans.example3.domen.City;
import rs.ds.trans.example3.domen.Company;
import rs.ds.trans.example3.facade.CoreFacade;
import rs.ds.trans.example3.repository.CityRepository;
import rs.ds.trans.example3.service.CityService;

/**
 *
 * @author user
 */
@Component
public class Start {

    @Autowired
    private CityRepository cityRepository;

    @Autowired
    private CityService cityService;

    @Autowired
    private CoreFacade coreFacade;

    public static void main(String[] args) {
        ApplicationContext context = new AnnotationConfigApplicationContext(TransPersistenceJPAConfig.class);

        Start start = (Start) context.getBean(Start.class);
        //start.workWithRepository();
        //start.workWithServise();
        start.workWithFacade();
    }

    //work with repository
    private void workWithRepository() {
        repoFindAllCity();
    }

    public void repoFindAllCity() {
        List<City> cities = cityRepository.findAll();
        for (City city : cities) {
            System.out.println(city);
        }
    }

    //work with service
    private void workWithServise() {
        serviceSaveCity(new City(1999l, "City - 1999l"));
        serviceFindAllCity();
    }

    public void serviceSaveCity(City city) {
        city = cityService.saveCity(city);
        System.out.println(city);
    }

    public void serviceFindAllCity() {
        List<City> cities = cityService.findAll();
        for (City city : cities) {
            System.out.println(city);
        }
    }

    //work with facade
    private void workWithFacade() {
        //facadeSaveCompany("COMPANY 99", 11000l);
        facadeSaveCompany("COMPANY 100", 105l,"City 105");        
        facadeFindAllCities();
    }

    private void facadeFindAllCities() {
        List<City> cities = coreFacade.findAllCities();
        for (City city : cities) {
            System.out.println(city);
        }
    }

    public void facadeSaveCompany(String name, Long ptt) {
        try {
            Company company = coreFacade.saveCompany(name, ptt);
            System.out.println(company);
        } catch (Exception ex) {
            System.err.println(ex.getMessage());
        }
    }

    public void facadeSaveCompany(String name, Long ptt, String cityName) {
        try {
            Company company = coreFacade.saveCompany(name, ptt, cityName);
            System.out.println(company);
        } catch (Exception ex) {
            System.err.println(ex.getMessage());
        }
    }
}
